#include <libCMU.h>
#include "soccer.h"


//----------------------------------
//   ï˸äƤΥѥ
//----------------------------------
Unum who_pass_team()
{
	Vector ball = Mem->BallAbsolutePosition();
	Vector ballvel = Mem->BallAbsoluteVelocity();
	Vector team_pos;
	float ball_stop_dis = ball.dist(ball_stop_position());
	float team_dis;
//	AngleDeg ball_ang = angle_point_to_point(ball, Vector((ball.x + ballvel.x), (ball.y + ballvel.y)));
	AngleDeg ball_ang = angle_point_to_point(ball, ball+(ballvel));
	AngleDeg team_ang , ang;
	Unum unum = 0;
	AngleDeg unum_ang = 20;


	for(Unum i = 1; i <= 11; i++){
		if(Mem->TeammatePositionValid(i)){
			team_pos = Mem->TeammateAbsolutePosition(i);
			team_dis = ball.dist(team_pos);
//			if(team_dis < ball_stop_dis + 10){
				team_ang = angle_point_to_point(ball,team_pos);
				ang = fabs(team_ang - ball_ang);
				if(ang < unum_ang){
					unum = i;
					unum_ang = ang;
//				}
			}
		}
	}

	return unum;				

}


//----------------------------------
//   ʬΥ̣ͤ뤫
//----------------------------------
int my_in_cone_team(Vector vec)
{
	AngleDeg pos_ang = Mem->AngleTo(vec);
	float pos_dis = Mem->DistanceTo(vec);
	AngleDeg ang = pos_dis / 2;
	float team_dis; 
	AngleDeg team_ang;
	AngleDeg ang1 = pos_ang - ang;
	AngleDeg ang2 = pos_ang + ang;
	int count = 0;

	for(Unum i = 1; i <= 11; i++){
		if(Mem->TeammatePositionValid(i)){
			team_dis = Mem->TeammateDistance(i);
			team_ang = Mem->TeammateAngle(i);
			if(team_dis <= pos_dis && team_ang >= ang1 && team_ang <= ang2){
				count++;
			}
		}
	}

	return count;

}


//----------------------------------
//   ܡ뤫ΥŨͤ뤫
//----------------------------------
int ball_in_cone_opp(Vector vec)
{
	Vector ball = Mem->BallAbsolutePosition();
	AngleDeg pos_ang = angle_point_to_point(ball,vec);
	float pos_dis = ball.dist(vec);
	AngleDeg ang = pos_dis / 2;
	float opp_dis; 
	Vector opp_pos;
	AngleDeg opp_ang;
	AngleDeg ang1 = pos_ang - ang;
	AngleDeg ang2 = pos_ang + ang;
	int count = 0;

	for(Unum i = 1; i <= 11; i++){
		if(Mem->OpponentPositionValid(i)){
			opp_pos = Mem->OpponentAbsolutePosition(i);
			opp_dis = ball.dist(opp_pos);
			opp_ang = angle_point_to_point(ball,opp_pos);
			if(opp_dis <= pos_dis && opp_ang >= ang1 && opp_ang <= ang2){
				count++;
			}
		}
	}

	return count;

}

//----------------------------------
//   ʬΥŨͤ뤫
//----------------------------------
int my_in_cone_opp(Vector vec)
{
	AngleDeg pos_ang = Mem->AngleTo(vec);
	float pos_dis = Mem->DistanceTo(vec);
	AngleDeg ang = pos_dis / 2;
	float opp_dis; 
	AngleDeg opp_ang;
	AngleDeg ang1 = pos_ang - ang;
	AngleDeg ang2 = pos_ang + ang;
	int count = 0;

	for(Unum i = 1; i <= 11; i++){
		if(Mem->OpponentPositionValid(i)){
			opp_dis = Mem->OpponentDistance(i);
			opp_ang = Mem->OpponentAngle(i);
			if(opp_dis <= pos_dis && opp_ang >= ang1 && opp_ang <= ang2){
				count++;
			}
		}
	}

	return count;

}


//----------------------------------
//   ܡߤ
//----------------------------------
Bool my_stop_ball()
{
	int kick_time;
	float ball_dis;

	if(Mem->BallKickable())
		return FALSE;

	if(Mem->BallSpeed() < 0.5)
		return FALSE;

	if(abs(Mem->CurrentTime.t - kick_time) <= 3 )
		return FALSE;

	kick_time = Mem->CurrentTime.t;
	ball_dis = Mem->BallDistance();


	stop_ball();

	return TRUE;
}
//-----------------------------
//   ïֻϤ˥󥿡ץȤǤ뤫
//-----------------------------
Unum first_intercepter()
{
	Unum i = 0;
	Unum unum = 0;
	Vector interception_point;
	float dis = 10000;
	Vector ball = Mem->BallAbsolutePosition();

	for(i = 1; i <= 11; i++){
		if(Mem->TeammatePositionValid(i) && Mem->TeammateInterceptionAble(i)){
			interception_point = Mem->TeammateInterceptionPoint(i);
			if(interception_point.dist2(ball) < dis){
				dis = interception_point.dist2(ball);
				unum = i;
			}
		}
		if(Mem->OpponentPositionValid(i) && Mem->OpponentInterceptionAble(i)){
			interception_point = Mem->OpponentInterceptionPoint(i);
			if(interception_point.dist2(ball) < dis){
				dis = interception_point.dist2(ball);
				unum = -i;
			}
		}

	}

	if(unum == Unum_Unknown)
		return Unum_Unknown;
	else
		return i;

}
//-----------------------------
//   ѥץ졼䡼
//-----------------------------
Bool pass_receive()
{
// ܡΤȼʬΤǥѥ뤫ȽǤ

//	Vector ball = Mem->BallAbsolutePosition();
	Unum passer = Mem->TeammateWithBall();
	if(passer ==  Unum_Unknown)
		return FALSE;
// ܡ뤬󤫤ä FALSE	
	if(Mem->BallDistance() > 50) 
		return FALSE;

// ʬեɤʤ FALSE
	if(teammate_offside(Mem->MyNumber)) 
		return FALSE;

// θ
	if(fabs(Mem->TeammateAbsoluteFace(passer) - Mem->TeammateAngle(passer)) < 130)
		return FALSE;

// ᤯꤬󤤤
	int t = 0;
	for(Unum i = 1; i <= 11; i++){
		if(Mem->OpponentPositionValid(i)){
			if(Mem->OpponentDistance(i) < 3){
				t++;
				if(t > 2){
					return  FALSE;
				}
			}
		}
	}

// ѥʤ
	t = 0;
	for(Unum i = 1; i <= 11; i++){
		if(Mem->OpponentPositionValid(i)){
			Vector a = Mem->TeammateAbsolutePosition(passer);
			Vector b = Mem->OpponentAbsolutePosition(i);
			if(angle_point_to_point(a,b) < 5){
				return FALSE;
			}
		}
	}

	return TRUE;
}

//--------------------------
//   ѥνФץ졼䡼
//--------------------------
// ѿ passer_unum  passer_unum_old
Unum passer_unum, passer_unum_old;

Unum last_with_ball_teammate()
{
	// unum ܡäƤ̣
	// unum_old ܡäƤ̣

	if(passer_unum_old > 11 || passer_unum_old <= 0)
		passer_unum_old = 1;

	passer_unum = Mem->TeammateWithBall();

	if(passer_unum == Unum_Unknown && passer_unum_old == Unum_Unknown)
		return Unum_Unknown;
	
	// ïܡäƤʤʬܡäƤ
	if(passer_unum == Unum_Unknown || passer_unum == Mem->MyNumber){
printf("%d  last_with_ball_teammatepasser_unum_old = %d\n",Mem->MyNumber,passer_unum_old);
		return passer_unum_old;
	}

	passer_unum_old = passer_unum;

printf("%d  last_with_ball_teammateunum = %d\n",Mem->MyNumber,passer_unum);
	return passer_unum;
}

//------------------------
//   ѥå
//------------------------
float pass_check_priority(Unum player){
		  
	double pass_angle = Mem->TeammateAngle(player);
	float diff_min = 180;

	for(Unum e = 1; e <= 11; e++){
		if (Mem->OpponentPositionValid(e) > 0.8){
			double diff_angle = fabs(Mem->OpponentAngle(e) - pass_angle);
			diff_min = diff_min < diff_angle? diff_min: diff_angle;
		}
	}

	return diff_min;
}

//------------------------
//   ѥͥ
//------------------------
int pass_priority(Unum* player)
{
	// t ϼʬ鸫Ƥ̣ο
	int t = front_player(player);
	Unum i;
	float *rate;
	rate = new float[11];

	for(i = 0; i < t; i++){
		// ˤ ץ饹ݥ
		rate[i] = (11 - i) * 2;

		if(Mem->TeammatePositionValid(player[i]) > 0.7){
			// եɥݥʤ ޥʥݥ
			if(Mem->TeammateX(player[i]) > offside_line()){
				rate[i] -= 150;
			}

			// ʬζ᤯꤬ݥȲ
			// ե꡼̣ϥݥȤ夲
			for(Unum u = 1; u <= 11; u++){
				if(Mem->OpponentPositionValid(u) > 0.8){
					if(player[i] == Mem->MyNumber){
						if(Mem->OpponentDistance(u) < 1){
							rate[i] -= 20;
						}else if(Mem->OpponentDistance(u) < 2){
							rate[i] -= 10;
						}else if(Mem->OpponentDistance(u) < 3){
							rate[i] -= 6;
						}
					}else{
						if(Mem->OpponentDistance(u) < 1){
							rate[i] -= 10;
						}else if(Mem->OpponentDistance(u) < 3){
							rate[i] -= 5;
						}
					}
				}
			}

			if((i == 10 && i == Mem->MyNumber) || (i == 11 && i == Mem->MyNumber)){
				if(Mem->MyX() > 30)
					rate[i] += 20;
				else if(Mem->MyX() > 10)
					rate[i] += 10;
				else
					rate[i] += 5;
			}
				
    
			if(Mem->TeammatePositionValid(player[i]) > 0.95){
				rate[i] += 20;
			}else if(Mem->TeammatePositionValid(player[i]) > 0.9){
				rate[i] += 10;
			}else if(Mem->TeammatePositionValid(player[i]) > 0.8){
				rate[i] += 5;
			}

			// ʬȤεΥǤΥݥ
			if(Mem->TeammateDistance(player[i]) > 50){
				rate[i] -= 20;
			}else if(Mem->TeammateDistance(player[i]) > 40){
				rate[i] -= 10;
			}else if(Mem->TeammateDistance(player[i]) > 30){
				rate[i] -= 5;
			}else if(Mem->TeammateDistance(player[i]) < 1.5){
				rate[i] -= 20;
			}else if(Mem->TeammateDistance(player[i]) < 3){
				rate[i] -= 10;
			}else if(Mem->TeammateDistance(player[i]) < 5){
				rate[i] -= 5;
			} 

			// ᤮ʤ ޥʥݥ
			if(Mem->TeammateX(player[i]) < -40){
				rate[i] -= 30;
			}
		      
			//Ǹ˥ܡạ̈ϥݥȤ򲼤
			Unum u = last_with_ball_teammate();
			if(Mem->TeammatePositionValid(u) && u == i){
				rate[i] -= 50;
			}

		
			// ʬ걦ˤ
			if(Mem->TeammateY(player[i]) < Mem->MyX()){
				rate[i] += 2;
			}
			
			// ˤʤץ饹ݥ
			if(Mem->TeammateY(player[i]) > 20){
				rate[i] += 5;
			}else if(Mem->TeammateY(player[i]) < -20){
				rate[i] += 5;
			}

			// ʬˤ
			if(Mem->TeammateX(player[i]) > Mem->MyX()){
				rate[i] += 15;
			}
		
			// ʬˤ
			if(Mem->TeammateX(player[i]) < (Mem->MyX() - 3)){
				rate[i] -= 20;
			}

			// ˤʤץ饹ݥ
			if(Mem->TeammateX(player[i]) > 40 && Mem->TeammateY(player[i]) < 16 
			   && Mem->TeammateY(player[i]) > -16){
				rate[i] += 7;
			}

			// ѥΥΥå
//       		float x = pass_check_priority(player[i]);
//			if(x < 5.0){
//				rate[i] -= 50;
//			}else if(x < 30){
//				rate[i] += x ;
//			}else{
//				rate[i] += 30;
//			}
			int x = my_in_cone_opp(Mem->TeammateAbsolutePosition(player[i]));
			if(x == 1){
				rate[i] -= 20;
			}else if(x > 1){
				rate[i] -= 80;
			}
		}

		printf("player = %d   rate = %f   \n",player[i],rate[i]);
	}

	for(i = 0; i < t; i++){
		rate[i] = -1 * rate[i];
	}

	BubbleSort(t,player,rate);

	delete rate;

	return t;

}

//------------------------
//   ̣ν
//------------------------
int front_player(Unum* player)
{
	int t = 0;
	Unum i;
	float *vals;
	vals = new float[11];
	    
	player[0] = Mem->MyNumber;

	for (i=1; i<=Mem->SP_team_size; i++){
		if(Mem->TeammatePositionValid(i)){
			player[t] = i;
			vals[t] = -Mem->TeammateX(i);
			t++;
		}
	}

	// t        Ƥ̣ο
	// player   ֹ
	// vals     ¤Ӵʾ
	BubbleSort(t,player,vals);
	delete vals;

	for(i = t; i < Mem->SP_team_size; i++){
		player[i] = 0;
	}

	return t;
}

//------------------------
//   ܡ˹Ԥ
//------------------------
void go_ball()
{
	if(Mem->BallSpeed() > 0.4){
		if(Mem->MyInterceptionAble()){
			go_to_point(Mem->MyInterceptionPoint(),0,100);
		}else{
			Vector point = Mem->BallAbsolutePosition();
			go_to_point(point,1,100);
		}
	}else{
		get_ball();
	}
}

//------------------------
//   κɸ˥å
//------------------------
Bool kick_to_xy ( Vector pos )
{
	if ( Mem->BallPositionValid() ){
		return ( kick_to ( (pos - Mem->BallAbsolutePosition())
			     .rotate(-Mem->MyAng()) ) )  ;
	}else{
		return ( FALSE ) ;
	}
}

//-------------------------
// ȵΥ˥å
//-------------------------
Bool kick_to ( Vector pos )
{
	float power ;

	if ( ( ! Mem->BallPositionValid() ) || ( ! Mem->BallKickable() ) ){
		return ( FALSE ) ;
	}

   power =  pos.mod() * ( 1.0 - Mem->SP_ball_decay ) /
             ( Mem->BallKickRate() *
                 ( 1.0 - 0.25 * ( Mem->BallAngle() / 180.0 )
                  - 0.25 * (( Mem->BallDistance() - Mem->SP_player_size
						- Mem->SP_ball_size )
					   / (Mem->SP_kickable_area )))) ;

	if ( power > Mem->SP_max_power )
		power = Mem->SP_max_power ;
	if ( power < Mem->SP_min_power )
		power = Mem->SP_min_power ;

	Vector addpower = Polar2Vector ( power, pos.dir() ) ;

	if ( Mem->BallVelocityValid() ){
		pos = addpower - Mem->BallAbsoluteVelocity() ;
	}

	kick ( pos.mod() , pos.dir()) ;         

	return TRUE;
}

Vector center,right,left,pc;
Vector shoot_right,shoot_left;

//--------------
//    
//--------------
void init()
{
	pc = Mem->MarkerPosition(Mem->RM_Their_PC_Flag);
	center       = Vector(52.49, 0);
	right        = Vector(52.5, 7.0);
	left         = Vector(52.5, -7.0);
	shoot_right  = Vector(52.5, 6.0);
	shoot_left   = Vector(52.5, -6.0);
}


//------------------------
//   塼
//------------------------
void shoot1()
{
	printf("shoot1 kick\n");

	if(!Mem->BallKickable()){
		return;
	}

	init();

	Unum goali_unum = Mem->ClosestOpponentTo(center);


//	Unum opp_unum = Mem->ClosestOpponent();

	Vector ball = Mem->BallAbsolutePosition();

	AngleDeg right_side, left_side;
	Vector near_side, far_side;

	right_side = angle_point_to_point(ball, right) - angle_point_to_point(ball, goali_unum);
	left_side = angle_point_to_point(ball, left) - angle_point_to_point(ball, goali_unum);

	KickMode kmode;

	Vector psol1, psol2;  // `

//	ᤤΥݥ
	if(Mem->DistanceTo(left) < Mem->DistanceTo(right)){
		near_side = shoot_left;
		far_side = shoot_right;
	}else{
		near_side = shoot_right;
		far_side = shoot_left;
	}

//	åζĴ

	if(Mem->DistanceTo(center) < 16 && 
	   RayCircleIntersect(ball, near_side, 3.5, 
			      Mem->OpponentAbsolutePosition(goali_unum),
			      &psol1, &psol2) == 0){
		kmode = KM_Quickly;
	}else if(Mem->DistanceTo(center) < 14 && 
	   RayCircleIntersect(ball, far_side, 5.0, 
			      Mem->OpponentAbsolutePosition(goali_unum),
			      &psol1, &psol2) == 0){
		kmode = KM_Quickly;
	}else if(Mem->DistanceTo(center) < 10)
		kmode = KM_Quickly;
	else if(Mem->DistanceTo(center) < 14)
		kmode = KM_Moderate;
	else
		kmode = KM_HardestKick;

//	kmode = Mem->BestKickModeAbs(near_side.dir());

	//ѡʤʤᤤ˥塼
	if(goali_unum == Unum_Unknown){
		kick_ball(near_side, kmode);

	}else if(RayCircleIntersect(ball, near_side, 2.5, Mem->OpponentAbsolutePosition(goali_unum),
		 &psol1, &psol2) == 0){
		kick_ball(near_side,kmode);
	}else{
		if((fabs(right_side) - fabs(left_side)) < -5){
			kick_ball(shoot_left, kmode); // Ƥʤ麸
		}else if((fabs(right_side) - fabs(left_side)) > 5){
			kick_ball(shoot_right, kmode); // 
		}else{
			kick_ball(near_side, kmode);
		}
	}


}


//----------------------------
//    ܡλߤޤ
//----------------------------
Vector ball_stop_position()
{
	Vector ball_stop_pos = Mem->BallAbsolutePosition();
	Vector ball_vel = Mem->BallAbsoluteVelocity();
	float ballspeed = Mem->BallSpeed();

	while(ballspeed >= 0.1){
		ball_stop_pos.x += ball_vel.x; 
		ball_stop_pos.y += ball_vel.y; 
		ball_vel.x *= Mem->SP_ball_decay;
		ball_vel.y *= Mem->SP_ball_decay;
		
		ballspeed *= Mem->SP_ball_decay;
	}

	return ball_stop_pos;
}

//----------------------------
//    եɥ饤
//----------------------------
float DF_offside_line()
{
	Vector ball = Mem->BallAbsolutePosition();
	float offside_line = ball.x;
	float first, second, temp;
	first = second = 0;

	for(Unum u = 1; u <= 11; u++){
		if(Mem->TeammatePositionValid(u)){
			if(Mem->TeammateAbsolutePosition(u).x < second){
				second = Mem->TeammateAbsolutePosition(u).x;
				if(second < first){
					temp = second;
					second = first;
					first = temp;
				}
			}
			
		}
	}

	offside_line = second;

	if(ball.x < offside_line)  offside_line = ball.x;
	if(offside_line > 0) offside_line = 0;

	return offside_line;
}

float offside_line()
{
	Unum opp_unum = Mem->FurthestForwardOpponent(FALSE);
	Vector ball = Mem->BallAbsolutePosition();
	float offside_line = ball.x;

	if(opp_unum != Unum_Unknown){
		offside_line = Mem->OpponentX(opp_unum);
	}

	//CMUΥեɥ饤

	if(offside_line > Mem->my_offside_line)
		offside_line = Mem->my_offside_line;

	if(ball.x > offside_line)  offside_line = ball.x;
	if(offside_line < 0) offside_line = 0;

	return offside_line;
}

//---------------------------------
//    ̣եɤɤ
//---------------------------------
Bool teammate_offside(Unum unum)
{
	if(!Mem->TeammatePositionValid(unum))	
		return FALSE;

	Vector pos = Mem->TeammateAbsolutePosition(unum);

	return ((pos.x <= offside_line()) ? FALSE : TRUE);

}
//--------------------------------------
//    ܡ뤬ʬ˸äƤ뤫
//--------------------------------------
Bool ball_to_my(float buffer)
{
//	if(Mem->BallRelativeVelocity().x > 0 && 
//	   Mem->BallRelativeVelocity().y > 0){
//		return FALSE;
//	}

	Vector pos = Mem->MyPos();
	return ball_to_point(pos,buffer);
}
//--------------------------------------
//    ܡ뤬ݥȤ˸äƤ뤫
//--------------------------------------
Bool ball_to_point(Vector point, float buffer)
{
	Vector ball = Mem->BallAbsolutePosition();
	Vector ballvel = Mem->BallAbsoluteVelocity();

	//ܡ뤬ưƤʤʤFALSE
	if(ballvel.x == 0 && ballvel.y == 0){
		return FALSE;
	}
	// ܡư狼ʤʤFALSE
	if(!Mem->BallVelocityValid()){
		return FALSE;
	}

	// ܡ뤬ʬΥƹԤʤFALSE
	if(ballvel.x < 0 && (ball.x - point.x) < 0)
		return FALSE;
	if(ballvel.x > 0 && (ball.x - point.x) > 0)
		return FALSE;
	if(ballvel.y < 0 && (ball.y - point.y) < 0)
		return FALSE;
	if(ballvel.y > 0 && (ball.y - point.y) > 0)
		return FALSE;

	Vector psol1, psol2;  // 

	return 
	((RayCircleIntersect(ball, ballvel, buffer, point, &psol1, &psol2) >= 1)
			? TRUE : FALSE);

}

//-----------------------
//    ѥ̤뤫
//-----------------------
Bool pass_check(Unum unum)
{
	double pass_angle = Mem->TeammateAngle(unum);
	double diff_min = 180;

	for(Unum e = 1; e <= 11; e++){
		if (Mem->OpponentPositionValid(e) > 0.8){
			double diff_angle = fabs(Mem->OpponentAngle(e) - pass_angle);
			diff_min = diff_min < diff_angle? diff_min: diff_angle;
		}
	}

	return diff_min > 5? TRUE: FALSE;
}
		

//-----------------------
//    point˥å
//-----------------------

//--- point ˥å ---
void my_kick(int power, Vector point)
{
	printf("%d my_kick_power\n",Mem->MyNumber);


	if(Mem->BallDistance() > 2) return;
	if(!Mem->BallKickable()){
		get_ball();
		return;
	}

	Vector ballrel = Mem->BallRelativePosition();
//	printf("before  ball ang = %f  dis = %f\n",ballrel.dir(),Mem->BallDistance());
//	Unum unum;

// ܡʬ˻äƤ
	if(fabs(Mem->AngleTo(point)) < 20){
		printf("TurnBall\n");
		if(fabs(ballrel.dir()) > 90){
			TurnballTo(Mem->AngleTo(point));
			return;
		}
	}


	printf("point X = %f  Y = %f\n",point.x,point.y);
	if(power < 90){
		kick(power, Mem->AngleTo(point));
	}else{
		kick_ball(Mem->AngleTo(point));
	}
}

//--- point ˤȻߤޤ ----
void my_kick(Vector point)
{
	printf("%d my_kick_point\n",Mem->MyNumber);


	if(Mem->BallDistance() > 2) return;
	if(!Mem->BallKickable()) get_ball();

	Vector ballrel = Mem->BallRelativePosition();

// ܡʬ˻äƤ
	if(fabs(Mem->AngleTo(point)) < 20){
		if(fabs(ballrel.dir()) > 120){
			printf("TurnBall\n");
			TurnballTo(Mem->AngleTo(point));
			return;
		}
	}

	if(my_stop_ball()){
		return;
	}else{
		kick_to_xy(point);
		return;
	}

}

//-----------------------
//    ڡ
//-----------------------

Vector space()
{
	int i, j;
	Vector vec = Mem->MyPos();
	Unum player0[12];
	Unum player1[12];
	for(i=0; i<12; i++){
		player0[i] = 0;
		player1[i] = 0;
	}
	AngleDeg ang = 0;
	i = j = 0;

	Mem->SortPlayersByDistanceToPoint('t', Mem->MyPos(), player0);

	while(player0[i] != 0 || j > 2){
		if(player0[i] != Unum_Unknown){
			if(Mem->OpponentX(player0[i]) >= Mem->MyX()){
				if(j == 0){  // j λ
					player1[j] = player0[i];
					ang = Mem->OpponentAngle(player1[j]);
					j++; //ʬˤο
				}else if(fabs(ang - Mem->OpponentAngle(player0[i])) < 5){
					player1[j] = player0[i];
					j++; //ʬˤο
				}
			}
		}
		i++;
		if((player0[i] == 0) || (j == 2))
			break;
	}

	if(j == 0){
		vec.x = Mem->MyPos().x + 15;
	}else if(j == 1){
		if(player1[0] != Unum_Unknown){
			AngleDeg ang1,ang2,o_ang;
			AngleDeg angle1, angle2, angle;
			ang1 = 50;	ang2 = -50;
			o_ang = Mem->OpponentAngle(player1[0]);

			angle1 = fabs(ang1 - o_ang);
			angle2 = fabs(ang2 - o_ang);

			if(angle1 > angle2){
				angle = angle1 / 2;
			}else{
				angle = angle2 / 2;
			}

			float dis = Mem->OpponentDistance(player1[0]);
			Vector my_pos = Mem->MyPos();
			vec.x = dis * cos(angle) + my_pos.x;
			vec.y = dis * sin(angle) + my_pos.y;


		}else{
			vec.x = Mem->MyPos().x + 3;
		}

	}else if(j == 2){ //꤬͸λͤ濴֤
		float a1,a2,b1,b2;
		double X;
		Vector P0,P1,P2;
		P0 = Mem->MyPos();
		P1 = Mem->OpponentAbsolutePosition(player1[0]);
		P2 = Mem->OpponentAbsolutePosition(player1[1]);

		if((X = (P0.x + P1.x)/2 - P2.x) == 0)
			X = 0.00000000001;
		a1 = ((P0.y + P1.y)/2 - P2.y) / X;
		b1 = P2.y - (a1 * P2.x);

		if((X = (P1.x + P2.x)/2 - P0.x) == 0)
			X = 0.00000000001;
		a2 = ((P1.y + P2.y)/2 - P0.y) / X;
		b2 = P0.y - (a2 * P0.x);

		if((X = (a2 - a1)) == 0)
			X = 0.00000000001;
		vec.x = (b1 - b2) / X;
		vec.y = a1 * vec.x + b1;
	}

	if(fabs(vec.y) > (Mem->SP_pitch_width / 2))
		vec.y = ((Mem->SP_pitch_width - 2) / 2);
		
	return vec;
}

Vector space_forward(){

	float dis = 0;
	int i;
	Vector pos;
	Unum player[24];
	for(i=0; i<24; i++)
		player[i] = 0;
	i = 0;
	

	pos.x = Mem->MyPos().x + dis * cos(Mem->MyAng());
	pos.y = Mem->MyPos().y + dis * sin(Mem->MyAng());

	while(dis <= 20){

		Mem->SortPlayersByDistanceToPoint('b', pos, player);

		if(player[0] == Mem->MyNumber){
			if((player[1] >= 12) && (Mem->OpponentDistanceTo(player[1],pos) < 
					  Mem->DistanceTo(pos)+0.5)){
				break;
			}else{ 
				dis += 2;
			}
		}else{
			break;
		}
		pos.x = Mem->MyPos().x + dis * cos(Mem->MyAng());
		pos.y = Mem->MyPos().y + dis * sin(Mem->MyAng());
	}
	return pos;
}

//-----------------------
//    θ
//-----------------------
Face my_face(){

	if(fabs(Mem->MyAng()) <= 30)
		return face_forward;
	else if(fabs(Mem->MyAng()) >= 150)
		return face_back;
	else if((Mem->MyAng() > 30) && (Mem->MyAng() <= 90))
		return face_fright;
	else if((Mem->MyAng() < -30) && (Mem->MyAng() >= -90))
		return face_fleft;
	else if((Mem->MyAng() > 90) && (Mem->MyAng() < 150))
		return face_bright;
	else if((Mem->MyAng() < -90) && (Mem->MyAng() > -150))
		return face_bleft;
	else
		return face_none;
}

Face teammate_face(Unum n){

	if(!Mem->TeammateFaceValid(n))
		return face_none;

	if(fabs(Mem->TeammateAbsoluteFace(n)) <= 30)
		return face_forward;
	else if(fabs(Mem->TeammateAbsoluteFace(n)) >= 150)
		return face_back;
	else if((Mem->TeammateAbsoluteFace(n) > 30) 
			  && (Mem->TeammateAbsoluteFace(n) <= 90))
		return face_fright;
	else if((Mem->TeammateAbsoluteFace(n) < -30) 
			  && (Mem->TeammateAbsoluteFace(n) >= -90))
		return face_fleft;
	else if((Mem->TeammateAbsoluteFace(n) > 90) 
			  && (Mem->TeammateAbsoluteFace(n) < 150))
		return face_bright;
	else if((Mem->TeammateAbsoluteFace(n) < -90) 
			  && (Mem->TeammateAbsoluteFace(n) > -150))
		return face_bleft;
	else
		return face_none;
}

Face opponent_face(Unum n){

	if(!Mem->OpponentFaceValid(n))
		return face_none;

	if(fabs(Mem->OpponentAbsoluteFace(n)) <= 30)
		return face_forward;
	else if(fabs(Mem->OpponentAbsoluteFace(n)) >= 150)
		return face_back;
	else if((Mem->OpponentAbsoluteFace(n) > 30) 
			  && (Mem->OpponentAbsoluteFace(n) <= 90))
		return face_fright;
	else if((Mem->OpponentAbsoluteFace(n) < -30) 
			  && (Mem->OpponentAbsoluteFace(n) >= -90))
		return face_fleft;
	else if((Mem->OpponentAbsoluteFace(n) > 90) 
			  && (Mem->OpponentAbsoluteFace(n) < 150))
		return face_bright;
	else if((Mem->OpponentAbsoluteFace(n) < -90) 
			  && (Mem->OpponentAbsoluteFace(n) > -150))
		return face_bleft;
	else
		return face_none;
}

//-------------------------------
//  ݥȤݥȤγ
//-------------------------------
AngleDeg angle_point_to_point(Vector point1,Vector point2)
{
	AngleDeg th;

	th = atan2(fabs(point1.y - point2.y), fabs(point1.x - point2.x));
	th = ATan(th);

	if((point1.y - point2.y) < 0)
		return th;
	else
		return -th;
}

//---------------------------------
//   ܡΰ
//---------------------------------
ball_pos ball_position(){
	Vector ball = Mem->BallAbsolutePosition();

	if(ball.x < -25){
		if(ball.y > 20){
			return pos1;
		}else if(ball.y > -20){
			return pos2;
		}else{
			return pos3;
		}
	}else if(ball.x < 10){
		if(ball.y > 20){
			return pos4;
		}else if(ball.y > -20){
			return pos5;
		}else{
			return pos6;
		}
	}else{
		if(ball.y > 20){
			return pos7;
		}else if(ball.y > -20){
			return pos8;
		}else{
			return pos9;
		}
	}
		

}

//----------------------------
//   ʬܡ˲ܤ˶ᤤ
//-----------------------------

int how_many_closer_teammate(Vector v)
{
  Unum teammate[] = {1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11};
  int n = Mem->SortPlayersByDistanceToPoint('m', v, teammate);
  int i = 0;
  for (i = 0; i < n; i++){
    if (teammate[i] == Mem->MyNumber)
      break;
  }
  return i;
}
