
#include <libCMU.h>
#include "soccer.h"
//-------------------------------------------------------------------------
//                   С
//-------------------------------------------------------------------------
void covering()
{
	printf("%d covering\n",Mem->MyNumber);
	
	
	
}

//-------------------------------------------------------------------------
//                   ѥλ
//-------------------------------------------------------------------------
Bool pass()
{
	printf("%d pass\n",Mem->MyNumber);

	Unum* player;
	player = new Unum[11];
	Unum unum = Mem->ClosestOpponent();
	Vector point;

	if(!Mem->BallKickable()) return FALSE;

	// ܡΥԡɤ®꤬᤯ˤʤܡߤ
	if(unum != Unum_Unknown && Mem->OpponentDistance(unum) > 3){
       		if(my_stop_ball()){
			return TRUE;
		}
	}
	
	// Υեɥ饤ˤʤ΢˥ѥ
	if(offside_line() < 0 && Mem->MyX() > -20){
		front_player(player);
		if(!teammate_offside(player[0])){
			point = Vector(35,0);
		}else{
			player = new Unum[11];
			pass_priority(player);

			if(Mem->TeammatePositionValid(player[0]) > 0.8 && 
					  player[0] != Mem->MyNumber){
				point = Mem->TeammateAbsolutePosition(player[0]);
			}else{
				return FALSE;
			}
		}
	}else{
		pass_priority(player);
		if(Mem->TeammatePositionValid(player[0]) > 0.8 && 
				  player[0] != Mem->MyNumber){
			point = Mem->TeammateAbsolutePosition(player[0]);
		}else{
			return FALSE;
		}
	}

/*
	if(unum != Unum_Unknown){
		// ᤯꤬ʤå򶯤
//		if(Mem->OpponentDistance(unum) > 3 && !Mem->BallKickable(0.7)){
//			get_ball();
		if(Mem->OpponentDistance(unum) > 3){
			kick_ball(point,KM_HardestKick);
		}else if(Mem->OpponentDistance(unum) > 3){
			kick_ball(point);
		}else{
			kick_ball(point,KM_Quickly);
		}
	}else{
		kick_ball(point);
	}
*/
	kick_ball(point,Mem->BestKickModeAbs(point.dir()));

	return TRUE;

}

//-------------------------------------------------------------------------
//                   եɥȥå
//-------------------------------------------------------------------------
Bool offside_trap_check()
{
	printf("%d offside_trap()\n",Mem->MyNumber);
	
	Unum first, second, temp;
	first = second = 0;
	float offside_line = DF_offside_line();

	Vector my_pos = Mem->MyPos();

	// ܡ˰ֶᤤ꤬[m]ʾʤ鼺
	if(Mem->PlayerWithBall(-1) >= 0)
		return FALSE;

	// ʬեɥ饤äƤʤ
	if(offside_line < my_pos.x)
		return FALSE;
	for(Unum e = 1; e <= 11; e++){
		if(Mem->TeammatePositionValid(e)){
			printf("e = %d    posX = %f\n",e,Mem->TeammateAbsolutePosition(e).x); 
			if(Mem->TeammateAbsolutePosition(e).x > offside_line
					  && Mem->TeammateAbsolutePosition(e).x - offside_line < 4){
				return FALSE;
			}
		}
	}

	// եɥ饤ζ᤯꤬ʤ
	for(Unum e = 1; e <= 11; e++){
		if(Mem->OpponentPositionValid(e)){
			if(Mem->OpponentAbsolutePosition(e).x - DF_offside_line() < 3){
				if(first == 0){
					first = e;
				}else{
					second = e;
					if(Mem->OpponentDistanceToBall(first) > Mem->OpponentDistanceToBall(second)){
						temp = first;
						first = second;
						second = temp;
					}
				}
			}
		}
	}
	if(first == 0)		return FALSE;


	Vector first_pos = Mem->OpponentAbsolutePosition(first);	
	Vector ball = Mem->BallAbsolutePosition();

	if(-Mem->PlayerWithBall(-1) == first)
		return FALSE;
	
	if(Mem->OpponentDistanceToBall(first) < Mem->SP_offside_area)
		return TRUE;

	if(fabs(first_pos.x - ball.x) < Mem->SP_offside_area)
		return TRUE;

	// ܡ뤫󤹤ʤ鼺
	if(Mem->OpponentDistanceToBall(first) > 30)
		return FALSE;

	// first ܡȤεΥᤤʤ
	if(Mem->OpponentDistanceToBall(first) < Mem->SP_offside_area)
		return TRUE;

	// ꤬եɤǤʤƼؤäƤʤ鼺
	if(first_pos.x > DF_offside_line() && Mem->OpponentAbsoluteVelocity(first).x > 0.2)
		return FALSE;

	if(second != 0){
		if(Mem->OpponentDistanceToBall(second) < Mem->SP_offside_area)
			return TRUE;

		Vector second_pos = Mem->OpponentAbsolutePosition(second);
		if(fabs(second_pos.x - ball.x) < Mem->SP_offside_area)
			return TRUE;
	}

	return TRUE;
}

void offside_trap()
{
	printf("%d  offside_trap\n",Mem->MyNumber);

	Vector pos = Mem->MyPos();
	pos.x += 5;

	go_to_point(pos,3,100);
}
//-------------------------------------------------------------------------
//                   ʬΥλ
//-------------------------------------------------------------------------
Bool my_turn()
{
	printf("%d  my_turn\n",Mem->MyNumber);

//printf("turn ang = %f\n",fabs(Mem->MyAng() - Mem->MarkerAngle(Mem->RM_Their_Goal)));
printf("my ang = %f\n",Mem->MyAng());
//printf("marker ang = %f\n",Mem->MarkerAngle(Mem->RM_Their_Goal));
printf("my marker ang = %f\n",angle_point_to_point(Mem->MyPos(),Mem->MarkerPosition(Mem->RM_Their_Goal)));
printf("turn ang = %f\n",fabs(Mem->MyAng() - angle_point_to_point(Mem->MyPos(),Mem->MarkerPosition(Mem->RM_Their_Goal))));

//	if(fabs(Mem->MyAng() - Mem->MarkerAngle(Mem->RM_Their_Goal)) < 60){
	if(fabs(Mem->MyAng() - angle_point_to_point(Mem->MyPos(),Mem->MarkerPosition(Mem->RM_Their_Goal))) < 60){
		return TRUE;
	}else if(fabs(Mem->MyAng() - Mem->BallAngle()) < 90){
		return TRUE;
	}else if(Mem->BallSpeed() > 0.5){
		stop_ball();
		return FALSE;
	}else{
		face_point(Mem->MarkerPosition(Mem->RM_Their_Goal));
		return FALSE;
	}
}

//-------------------------------------------------------------------------
//                   ݥȥץ졼
//-------------------------------------------------------------------------
Action post_play()
{
	printf("%d  post_play\n",Mem->MyNumber);

	int i;
	Unum player[13];
	for(i=0; i<13; i++)
		player[i] = 0;
	Unum unum;
	Vector pos;
	i = 0;

//	my_turn();

	if((unum = Mem->ClosestOpponent()) != Unum_Unknown){
		if(Mem->OpponentDistance(unum) > 3){
			if(my_turn())
				dribble();
			else
				printf("BBBBB\n");
		}else{
			Mem->SortPlayersByDistanceToPoint('m',Mem->MyPos(),player);

			while(player[i] != 0){
				if(player[i] != Unum_Unknown){
					pos = Mem->TeammateAbsolutePosition(player[i]);
					if((unum = Mem->ClosestOpponentTo(pos)) != Unum_Unknown){
						if(Mem->OpponentDistanceTo(unum, pos) > 3 ){
//							pass_ball(player[i]);
							break;
						}
					}else{
//						pass_ball(player[i]);
						break;
					}
				}
				i++;
			}

			// ̣ե꡼λ
			if(player[i-1] != Unum_Unknown){
//				pass_ball(player[i-1]);
				Vector pass_point = Mem->TeammateAbsolutePosition(player[i-1]);
				pass_point.x += 2;
				my_kick(pass_point);
			}else{
				if(my_turn())
					dribble();	
				else
					printf("BBBBB\n");
			}
		}
	}else{
		if(my_turn())
			dribble();
		else
			printf("BBBBB\n");
	}

	return AC_post;
}

//-------------------------------------------------------------------------
//                  	ڡ򸫤Ĥ˰ư 
//-------------------------------------------------------------------------

//----------  ǥե󥹤ΤȤ--------------------
Action DF_run_select()
{
	printf("%d  DF_run_select\n",Mem->MyNumber);

	Unum near_ball_tea_unum = Mem->ClosestTeammateToBall();
	Unum near_ball_opp_unum = Mem->ClosestOpponentToBall();

	Vector point;
	Vector ball = Mem->BallAbsolutePosition();
	Vector near_ball_tea_pos, near_ball_opp_pos;
	if(near_ball_tea_unum != Unum_Unknown)
		near_ball_tea_pos = Mem->TeammateAbsolutePosition(near_ball_tea_unum);
	if(near_ball_opp_unum != Unum_Unknown)
		near_ball_opp_pos = Mem->OpponentAbsolutePosition(near_ball_opp_unum);

	if(Mem->BallKickable()){
		if((Mem->MyNumber % 2) == 0){
			my_kick(100,Vector(35,-10));
		}else{
			my_kick(100,Vector(35,10));
		}
	}else if(Mem->ClosestTeammateToBall() == Mem->MyNumber){
		point = Vector(ball.x - 1, ball.y);
		if(go_to_point(point) == AQ_ActionNotQueued)
			get_ball();
	}else if(ball.x < -10){
		new_position();		 
	}else if(how_many_closer_teammate(ball) > 2){
		new_position();
	}else if(ball.y > 0 && (Mem->MyNumber % 2) == 1){
		new_position();
	}else if(ball.y < 0 && (Mem->MyNumber % 2) == 0){
		new_position();
	}else if(ball.y < 0){
		point.x = ball.x - 3;
		point.y = ball.y + 2;
		if(go_to_point(point,1.5) == AQ_ActionNotQueued)
			face_ball();
	}else{
		point.x = ball.x - 3;
		point.y = ball.y - 2;
		if(go_to_point(point,1.5) == AQ_ActionNotQueued)
			face_ball();
	}

	return AC_DF;
}

//-------------------------------------------------------------------------
//                    ѥνФ
//-------------------------------------------------------------------------
Action pass_select()
{
	printf("%d  pass_select\n",Mem->MyNumber);

	Vector pass_point;
	Vector goali_pos;
	Unum goali_unum, unum;
	Unum opp_unum = Mem->ClosestOpponent();
	Unum far_opp_unum = Mem->FurthestForwardOpponent(FALSE);

	Unum rside_tea_unum = Mem->ClosestTeammateTo(Vector(Mem->MyX(), 27));
	if(rside_tea_unum != Unum_Unknown && 
			  Mem->TeammateDistanceTo(rside_tea_unum,Vector(Mem->MyX(), 27)) > 10)
		rside_tea_unum = Unum_Unknown;

	Unum lside_tea_unum = Mem->ClosestTeammateTo(Vector(Mem->MyX(), -27));
	if(lside_tea_unum != Unum_Unknown && 
			  Mem->TeammateDistanceTo(lside_tea_unum,Vector(Mem->MyX(), -27)) > 10)
		lside_tea_unum = Unum_Unknown;


	if((goali_unum = Mem->ClosestOpponentTo(Mem->MarkerPosition(Mem->RM_Their_Goal)))
			  != Unum_Unknown){
		goali_pos = Mem->OpponentAbsolutePosition(goali_unum);
	}

	if ( Mem->MarkerDistance(Mem->RM_Their_Goal) < 23 ){
		// 塼Ƚʤ饷塼
		shoot();
		return AC_pass;
	}

	if(opp_unum != Unum_Unknown && opp_unum != goali_unum){
		if(Mem->OpponentAbsolutePosition(opp_unum).x > Mem->MyX()-2 &&
			Mem->OpponentDistance(opp_unum) > 3){
			my_dribbleto(Vector(35,0),100,3);
			return AC_dribble;
		}
	}


	if(fabs(Mem->my_offside_line - Mem->MyX()) < 2){
		my_dribbleto(Vector(35,0),100,4);
		return AC_dribble;
	}


	// ֶᤤ̣ʤ
	if((unum = Mem->ClosestTeammate()) != Unum_Unknown ){
		if(Mem->TeammateAbsolutePosition(unum).x > Mem->MyPos().x && pass_check(unum)){
			pass_ball(unum,Mem->TeammateSpeed(unum));
		}else if(opp_unum != Unum_Unknown && Mem->OpponentDistance(opp_unum) > 3){
			if(my_turn())
				dribble();
			else
				printf("CCCCCC\n");
		}else if(opp_unum == Unum_Unknown){
			if(my_turn())
				dribble();
		}else if(far_opp_unum != Unum_Unknown){
			pass_point.x = Mem->OpponentAbsolutePosition(far_opp_unum).x;
			if((Mem->MyNumber % 2) == 0){
				pass_point.y = Mem->MyPos().y - 10;
				kick_ball(pass_point);
			}else{
				pass_point.y = Mem->MyPos().y + 10;
				kick_ball(pass_point);
			}
		}else if((Mem->MyNumber % 2) == 0){
			pass_point.x = Mem->MyPos().x + 5;
			pass_point.y = Mem->MyPos().y - 10;
			kick_ball(pass_point);
		}else{
			pass_point.x = Mem->MyPos().x + 5;
			pass_point.y = Mem->MyPos().y + 10;
			kick_ball(pass_point);
		}

	}else if(rside_tea_unum != Unum_Unknown && pass_check(rside_tea_unum)){
		pass_ball(rside_tea_unum);
	}else if(lside_tea_unum != Unum_Unknown && pass_check(lside_tea_unum)){
		pass_ball(lside_tea_unum);

	}else{
		// ʡƨ
		printf("%d kick_from_conner\n",Mem->MyNumber);
		if((Mem->MyNumber % 2) == 0){
			pass_point = Mem->MarkerPosition(Mem->RM_LF_Flag);
			pass_point.y += 1;
		}else{
			pass_point = Mem->MarkerPosition(Mem->RM_RF_Flag);
			pass_point.y -= 1;
		}
		pass_point.x -= 7;
		kick_ball(pass_point);
	}

	return AC_pass;
}

//------------------------------------------------------------------------
//                    ɥ֥
//------------------------------------------------------------------------
Action dribble()
{
	printf("%d  dribble\n",Mem->MyNumber);

	Vector goali_pos;
	Unum goali_unum;
	Unum unum;
//	Unum opp_unum;
//	Vector point = Mem->MarkerPosition(Mem->RM_Their_Goal);

	Rectangle rect = Rectangle(33,52.5,-17,17);

	if(!Mem->BallKickable()){
		get_ball();
		return AC_none;
	}

	if((goali_unum = Mem->ClosestOpponentTo(Mem->MarkerPosition(Mem->RM_Their_Goal)))
			  != Unum_Unknown){
		goali_pos = Mem->OpponentAbsolutePosition(goali_unum);
	}
			 
	Vector space_point = space();

	//εΥ[m]ʤ饷塼ȴؿ
//	if(Mem->MarkerDistance(Mem->RM_Their_Goal) < 25 ){
	if(rect.IsWithin(Mem->MyPos())){
		shoot();

	//ؤʤɥ֥뤷ʤ
	}else if(Mem->MyPos().x < -2){
		if(pass()){
			return AC_pass;
		}else if(Mem->MyY() > 0){
			my_kick(100,Vector(35,-15));
		}else{
			my_kick(100,Vector(35,15));
		}

//	//οϤοʤɥ֥ͥ
//	}else if(Mem->MyPos().x > 32){
//		FW_dribble();

	}else if((unum = Mem->ClosestOpponent()) != Unum_Unknown && Mem->OpponentDistance(unum) < 3){
		if(fabs(Mem->MyPos().y) < 15){
			unum = Mem->ClosestTeammateTo(Vector(offside_line() - 5, -25));
			if(Mem->TeammateDistanceTo(unum, Vector(offside_line() - 5, 25)) < 5){
				kick_to_xy(Vector(35,25));
			}else if(Mem->TeammateDistanceTo(unum, Vector(offside_line() - 5, -25)) < 5){
				kick_to_xy(Vector(35,-25));
			}else{
				kick_to_xy(Vector(35,Mem->MyY()));
			}
		}else if(Mem->MyPos().y < 0){
			kick_to_xy(Vector(35,(Mem->MyY() + 2)));
		}else{
			kick_to_xy(Vector(35,(Mem->MyY() - 2)));
		}
	}else if((space_point.x > (Mem->MyX() + 3)) && (fabs(space_point.y) < (fabs(Mem->MyY())) - 3)){
		printf("dribble     space =  my_pos+5\n");
		if((unum = Mem->ClosestOpponent()) != Unum_Unknown && 
				 Mem->OpponentAbsolutePosition(unum).x > Mem->MyPos().x && 
				 Mem->OpponentDistance(unum) > 7){
			Vector point = Mem->MyPos();
			point.x += 4;
			my_dribbleto(point,100, 0);

		}else{
			printf("%d  space_dribble\n",Mem->MyNumber);
			my_dribbleto(space_point,100, 0);
		}
	}else if(Mem->BallAbsolutePosition().x == offside_line()){
		if(fabs(Mem->MyPos().y) < 15){
			kick_to_xy(Vector(35,Mem->MyY()));
		}else if(Mem->MyPos().y < 0){
			kick_to_xy(Vector(35,(Mem->MyY() + 2)));
		}else{
			kick_to_xy(Vector(35,(Mem->MyY() - 2)));
		}


	}else{
		if(pass()){
			return AC_dribble;
		}else{
			Vector point1 = Mem->MyPos();
			point1.x += 4;
			if(Mem->MyY() > 20){
				point1.y -= 3;
			}else if(Mem->MyY() > 0){
				point1.y -= 1.5;
			}else if(Mem->MyY() < -20){
				point1.y += 3;
			}else if(Mem->MyY() < 0){
				point1.y += 1.5;
			}

			my_dribbleto(point1,100,0);
			return AC_dribble;
		}
	}

	return AC_dribble;
}

//-------------------------------------------------------------------------
//                    FWΥɥ֥
//-------------------------------------------------------------------------
void FW_dribble()
{
	printf("%d FW_dribble\n",Mem->MyNumber);

	Vector point = Mem->MyPos();

	Vector goali_pos;
	Unum goali_unum;
	Unum unum;

	if((goali_unum = Mem->ClosestOpponentTo(Mem->MarkerPosition(Mem->RM_Their_Goal)))
			  != Unum_Unknown){
		goali_pos = Mem->OpponentAbsolutePosition(goali_unum);
	}

	int t = 0;
	if(fabs(Mem->MyAng() - Mem->MarkerAngle(Mem->RM_Their_Goal)) > 6){
		for(Unum i = 1; i <= 11; i++){
			if(Mem->OpponentPositionValid(i) > 0.95 && !Mem->InViewAngle(i)){
				t++;
			}
		}
	}
			
printf("t = %i \n",t);


	if(goali_unum != Unum_Unknown){
		if(fabs(Mem->MyPos().y) < 15){
			point = Vector(35,0);
		}else if(Mem->MyPos().y > 0){
			point = Vector(38,6.6);
		}else{
			point = Vector(38,-6.6);
		}

		unum = Mem->ClosestOpponent();
		if(Mem->OpponentDistance(unum) > 6)
			point.x += 1;

		if(unum != Unum_Unknown){
			if(Mem->OpponentDistance(unum) > 6){
				my_dribbleto(point,100, 0);
			}else{
				shoot();
			}
		}else{
			my_dribbleto(point,100,1);
		}
//	}else if(t == 0){
//		shoot1();
	}else if(t == 1){
		shoot();
//		my_dribbleto(Vector(40,0),100,2);
	}else if(fabs(Mem->AngleTo(Mem->MarkerPosition(Mem->RM_Their_Goal))) < 70){
		shoot();
	}else{
//		my_turn();
		TurnballTo(Mem->AngleTo(Vector(50,0)));
	}

}

//-------------------------------------------------------------------------
//                    DribbleTo
//------------------------------------------------------------------------
void my_dribbleto(Vector point,float max_dash_pow, float buffer)
{
	printf("%d my_dribble\n",Mem->MyNumber);

	Unum unum;
	Vector opponent_pos;
	AngleDeg opponent_ang;
	Vector my_pos = Mem->MyPos();
	Vector goal = Vector(52.5,0);
	AngleDeg ang = 0;

printf("goal dis = %f\n",Mem->DistanceTo(goal));

//	Vector space_point = space();

	if(Mem->MyPos().x > 50){
		if(Mem->MyPos().y > 0)
			ang = -80;
		else
			ang = 80;
	}else if(Mem->DistanceTo(goal) < LAST_SHOOT_DIS){
		ang = Mem->AngleTo(goal);
		shoot1();
//	}else if(space_point.x > my_pos.x && fabs(space_point.y) < 15){
//		ang = Mem->AngleTo(space_point) + 180;
	}else if((unum = Mem->ClosestOpponent()) != Unum_Unknown){
		opponent_pos = Mem->OpponentAbsolutePosition(unum);
		opponent_ang = Mem->OpponentRelativePosition(unum).dir();
printf("closest opp dis = %f\n",Mem->OpponentDistance(unum));
printf("closest opp ang = %f\n",Mem->OpponentAngle(unum));
		if(Mem->OpponentDistance(unum) > 10){
//			ang = Mem->AngleTo(goal);
			ang = 0;
		}else if(opponent_pos.x > my_pos.x){
			if(opponent_pos.y > my_pos.y)
				ang = -30;
			else
				ang = 30;
		}else if(fabs(my_pos.y) > 20){
			ang = 0;
		}
	}else{
		ang = 0;
	}

	AngleDeg point_ang, ang1, ang2;
	AngleDeg opp_ang;
	Vector opp_pos;
	for(Unum i = 0; i <= 11; i++){
		if(Mem->OpponentPositionValid(i)){
			point_ang = angle_point_to_point(Mem->MyPos(), point);
			ang1 = point_ang + 25;
			ang2 = point_ang - 25;
			opp_pos = Mem->OpponentAbsolutePosition(i);
			opp_ang = angle_point_to_point(Mem->MyPos(), opp_pos);
			if(Mem->OpponentDistance(i) < 1.5 && opp_ang < ang1 && opp_ang > ang2){
//				ang = Mem->OpponentAngle(i) + 180;
printf("hold_ball\n");
				hold_ball();
				return;
				break;
			}
		}
	}
			


	printf("stamina = %f\n",Mem->MyStamina());
	if(Mem->MyStamina() < 1500){
		point.x = (point.x + Mem->MyX()) / 2;
		point.y = (point.y + Mem->MyY()) / 2;
		if(Mem->DistanceTo(point) < 2){
			hold_ball();
			return;
		}
	}

printf("ang = %f\n",ang);
{
	// ɥ֥Υƥ
	AngleDeg test_ang = angle_point_to_point(Mem->MyPos(),point);;
	Vector test_pos_a[13] = {0,0,0,0,0,0,0,0,0,0,0,0,0}; // ݥȤ˽񤤤α¦ˤŨ
	Vector test_pos_b[13] = {0,0,0,0,0,0,0,0,0,0,0,0,0}; // ݥȤ˽񤤤κ¦ˤŨ
	AngleDeg test_ang1;
	Vector test_pos;
	int a = 0, b = 0;

	for(Unum e = 1; e <= 11; e++){
		if(Mem->OpponentPositionValid(e)){
			test_pos = Mem->OpponentAbsolutePosition(e);
			test_ang1 = angle_point_to_point(Mem->MyPos(), test_pos);
			if(Mem->DistanceTo(point) <  point.dist(opp_pos))
				continue;
			else if(Mem->OpponentDistance(e) < 2)
				continue;
			else if((test_ang1 - test_ang) > 0)
				test_pos_a[a++] = test_pos;
			else
				test_pos_b[b++] = test_pos;
		}
	}

	Vector test_point = point; // äƤѹ
	Vector new_test_point; 
	float pos_dis = Mem->DistanceTo(point), new_pos_dis;
	for(int t = 0; t < a; t++){
		for(int j = 0; j < b; j++){
			new_test_point = (test_pos_a[t] + test_pos_b[j]) / 2;
			new_pos_dis = Mem->DistanceTo(test_point);
			if(new_pos_dis < 1.5)
				continue;
			else if(new_pos_dis < pos_dis){
				pos_dis = new_pos_dis;
				test_point = new_test_point;
			}
		}
	}
	if(a == 0 && b > 0){
		test_point.y -= 2;
	}else if (a > 0 && b ==0){
		test_point.y += 2;

	}

	if(Mem->MyX() > 35)
		;
	else if(Mem->DistanceTo(point) > test_point.dist(point))
		point = test_point;
}

//	if(fabs(point.x) < (fabs(Mem->MyPos().x) - 1)
printf("mypos X = %f,   Y = %f\n",Mem->MyPos().x,Mem->MyPos().y);
printf("point X = %f,   Y = %f\n",point.x,point.y);

	if((unum = Mem->ClosestOpponent()) != Unum_Unknown){
		Vector pos = Mem->OpponentAbsolutePosition(unum);
		if(fabs(Mem->BallY()) > 16 && Mem->BallX() > 32 && Mem->OpponentDistance(unum) > 6){
			DribbleTo(point,max_dash_pow,buffer,0,DM_Lazy,FALSE,Vector(0,0));
//		}else if(Mem->OpponentDistance(unum) > 6){
//			point.x -= 1;
//			kick_to_xy(point);
		}else if(pos.x < (my_pos.x - 1)){
			DribbleTo(point,max_dash_pow,buffer,0,DM_Lazy,FALSE,Vector(0,0));
		// ꤬ޤäƤƨ
//		}else if(Mem->OpponentDistance(unum) < 2.5 && pos.x > (Mem->MyX() + 0.5)){
//			kick_to_xy(point);
		}else{
//			DribbleTo(point,max_dash_pow,buffer,ang,DM_Lazy,FALSE,Vector(0,0));
//			DribbleTo(point,max_dash_pow,buffer,0,DM_Strict,FALSE,Vector(0,0));
printf("dribble srtict\n");
			DribbleTo(point,max_dash_pow,buffer,ang,DM_Strict,TRUE,point);
		}
	}else{
//		DribbleTo(point,max_dash_pow,buffer,ang,DM_Lazy,FALSE,Vector(0,0));
printf("dribble kick\n");
			kick_to_xy(point);
	}
}


