#include  "sserver_misc_funcs.h"
#include  <cmath>

using namespace std;

D2_Vector  ball_point_n_turn_later( const SServer_Param &  param ,
				    const D2_Vector &  current_point ,
				    const D2_Vector &  vec ,
				    int  n )
{
#if 1
	return( current_point
		+ vec
		  * (1.0 - pow( param.BALL_DECAY() , static_cast<double>(n) ))
		  / (1.0 - param.BALL_DECAY()) );
#else

	if ( n == 0 )
	{
		return( current_point );
	}
	else // if ( n > 0 )
	{
		return( ball_point_n_turn_later( param ,
						 current_point ,
						 vec * param.BALL_DECAY() ,
						 n - 1 )
			+ vec );
	}
#if 0
	else // if ( n < 0 )
	{
	}
#endif
#endif
}


#if 0
double  full_power_dash_dist( const SServer_Param &  param ,
			      int  n ,  double  current_speed )
{
	if ( n == 0 )
	{
		return( 0.0 );
	}
	else // if ( n > 0 )
	{
		return( current_speed
			+ full_power_dash_dist( param , n - 1 ,
						current_speed
						* param.PLAYER_DECAY() ) );
	}
#if 0
	else // if ( n < 0 )
	{
	}
#endif
}
#endif
