#include <libCMU.h>
#include <zeng.h>

// CMF
void CMF_behave()
{
	double buffer = minimal_buffer() ;
	if ( mode_action() == TRUE ) return ;
	//CMF
/*ܡ뤬ʤ*/
	if (!Mem->BallPositionValid()){
		face_ball();
	}
	else
	{
		if ( Mem->BallKickable() )
		{
			double danger_val = get_danger_val ( 20 ) ;
#if 1
			if ( Mem->BallMoving() )
			{
				if (Mem->BallVelocityValid() &&
				    Mem->BallAbsoluteVelocity().mod() > 1.5 )
				{
					stop_ball() ;
					return ;
				}
			}
#endif
			if ( shoot_near_post() == TRUE ) return ;

			Vector vec = Vector ( 40 , 0 ) ;

			if ( danger_val < 0.2 )
			{
				if ( DR_None == DribbleTo(vec , 100 , 0 , Mem->CP_dribble_angle_norm,
							  DM_Lazy, FALSE, vec ) )

				{
					if ( MF_pass_side () == TRUE )	return ;
					if ( MF_pass_forward () == TRUE ) return ;
					if ( MF_pass_center () == TRUE ) return ;
					//hold_ball() ;
					kick_ball (Vector ( 52.5 , 0 ) , KM_HardestKick ,TURN_AVOID) ;
					return ;
				}
				return ;
			}
			else if ( danger_val < 0.3 )
			{
			/*Vec, speed, buffer, YoKeru kakudo,yokeru yokenai
			  , Kimeuti suruka douka , kimeuti zahyou */

#if 1
				if ( Mem->my_offside_line <= 10 && Mem->MyX() < 30 )
				{
					if ( forward_pass(vec) == TRUE ) return ;
				}
				else
				{
					if ( MF_pass_forward () == TRUE ) return ;
					if ( MF_pass_side () == TRUE )	return ;
				}
#endif
				if ( DR_None == DribbleTo(vec , 100 , 0 , Mem->CP_dribble_angle_norm,
							  DM_Lazy, FALSE, vec ) )

				{
					if ( MF_pass_side () == TRUE )	return ;
					if ( MF_pass_forward () == TRUE ) return ;
					if ( MF_pass_center () == TRUE ) return ;
					//hold_ball() ;
					kick_ball (Vector ( 52.5 , 0 ) , KM_HardestKick ,TURN_AVOID) ;
					return ;
				}
				return ;
			}
			else if ( danger_val < 0.6 )
			{
				if ( Mem->my_offside_line <= 10 && Mem->MyX() < 30 )
				{
					if ( forward_pass(vec) == TRUE ) return ;
				}

				if ( MF_pass_forward () == TRUE ) return ;
				if ( MF_pass_side () == TRUE ) return ;
				if ( MF_pass_center () == TRUE ) return ;
			}
			else
			{
				if ( Mem->my_offside_line <= 10 && Mem->MyX() < 30 )
				{
					if ( forward_pass(vec) == TRUE ) return ;
				}

				if ( MF_pass_forward () == TRUE ) return ;
				if ( MF_pass_side () == TRUE ) return ;

				if ( MF_pass_center () == TRUE )
				{
					return ;
				}
				else
				{
					//hold_ball() ;
					kick_ball (Vector ( 36.0 , 0 ) , KM_HardestKick ,TURN_AVOID) ;
					return ;
				}
			}
		}
		else if ( ball_to_my ( 6.0 ) )
		{
			if ( get_ball_to_own(buffer) == TRUE )
			{
				return ;
			}
			else
			{
				face_ball() ;
				return ;
			}
		}
		else if ( how_many_closer_teammate(Mem->BallAbsolutePosition() ) < 2)
		{
			if ( Mem->PlayerWithBall() >= 2 )
			{
				if ( go_to_point(Mem->BallAbsolutePosition(),buffer , 30 ) == AQ_ActionNotQueued )
				{
					face_ball() ;
				}
			}
			else
			{
				chase_ball ( buffer ) ;
			}

			return ;
		}
#if 0
		else if ( Mem->BallWillBeKickable( 2 , 100 ) )
		{
			if (Mem->PlayerWithBall() <= 0)/*ŨܡäƤ*/
				go_to_point(Mem->BallAbsolutePosition(),buffer) ;
		}
#endif
		else
		{
			if ( Mem->BallPositionValid() )
			{
				if ( Mem -> BallAbsolutePosition().x < -25 )
				{
					if ( go_to_point ( MyProp -> init_pos , buffer , 40 ) == AQ_ActionNotQueued )
					{
						face_ball() ;
					}
					return ;
				}
				else if ( fabs ( Mem -> BallAbsolutePosition().x - Mem->MyPos().x) > 10
					  && (Mem-> BallAbsolutePosition().x < Mem->MyPos().x) )
				{
					if ( go_to_point(Vector(Mem->BallAbsolutePosition().x - 3 ,MyProp->init_pos.y) ,buffer , 50 ) == AQ_ActionNotQueued )
					{
						face_ball() ;
					}
				}
				else if ( fabs ( Mem -> BallAbsolutePosition().x - Mem->MyPos().x) > 10  )
				{
					if ( go_to_point(Vector(Mem->BallAbsolutePosition().x - 5 , MyProp->init_pos.y) , buffer , 40 ) == AQ_ActionNotQueued )
					{
						face_ball() ;
					}
				}
				else
				{
					if ( go_to_point(Vector(Mem->BallAbsolutePosition().x , MyProp->init_pos.y) , buffer , 40 ) == AQ_ActionNotQueued )
					{
						face_ball() ;
					}
				}
				return ;
			}
			else
			{
				face_ball();
				return ;
			}
		}
	}
}
