#include <libCMU.h>
#include <zeng.h>

// DF
void DF_behave()
{
	double buffer = minimal_buffer();
	if ( mode_action() == TRUE ) return ;

	if (!Mem->BallPositionValid())
	{
		face_ball();
		return ;
	}
	else
	{
		if (Mem->BallKickable())
		{
#if 1
			if ( Mem->BallVelocityValid() )
			{
				if ( Mem->BallSpeed() > 1.5 )
				{
					stop_ball() ;
					return ;
				}
			}
#endif
#if 0
			for ( Unum u = 5 ; u <= 11 ; ++ u )
			{
				if ( through_pass(u) == TRUE ) return ;
			}
#endif
			DF_clear() ;
			return ;
		}
		else if ( Mem->ClosestTeammateToBall() == Mem->MyNumber )
		{
			if ( Mem->BallInOwnPenaltyArea() )
			{
				if ( Mem->TeammatePositionValid(1) )
				{
					if ( Mem->BallX() < Mem->TeammateAbsolutePosition(1).x )
					{
						// if (go_to_point( Vector ( Mem->BallX() , Mem->BallY() ) , buffer , 100 , FALSE) == AQ_ActionNotQueued )
						if (go_to_point( Vector ( Mem->BallX() , Mem->BallY() ) , buffer , 100 ) == AQ_ActionNotQueued )
						{
							face_ball();
							return ;
						}
						return ;
					}
				}
				else
				{
					// if (go_to_point( Vector ( Mem->BallX() , Mem->BallY() ) , buffer , 100 , TRUE) == AQ_ActionNotQueued )
					if (go_to_point( Vector ( Mem->BallX() , Mem->BallY() ) , buffer , 100) == AQ_ActionNotQueued )
					{
						face_ball();
						return ;
					}
					return ;
				}
			}
			else
			{
				chase_ball(buffer) ;
			}
			return ;
		}
		else if ( Mem->BallInOwnPenaltyArea() )
		{
			if ( Mem->TeammatePositionValid(1) )
			{
				if ( ( Mem->BallX() < Mem->TeammateAbsolutePosition(1).x ) && Mem->ClosestTeammateToBall() != 1 )
				{
					// if (go_to_point( Vector ( Mem->BallX() , Mem->BallY() ) , buffer , 100 , FALSE) == AQ_ActionNotQueued )
					if (go_to_point( Vector ( Mem->BallX() , Mem->BallY() ) , buffer , 100 ) == AQ_ActionNotQueued )
					{
						face_ball() ;
						return ;
					}
					return ;
				}
				else
				{
					if (go_to_point( MyProp->pos , buffer , 50 ) == AQ_ActionNotQueued )
					{
						face_ball();
						return ;
					}				
				}
			}
			else
			{
				//if (go_to_point( Vector ( Mem->BallX() , Mem->BallY() ) , buffer , 100 , TRUE) == AQ_ActionNotQueued )
				if (go_to_point( Vector ( Mem->BallX() , Mem->BallY() ) , buffer , 100 ) == AQ_ActionNotQueued )
				{
					face_ball();
					return ;
				}
				return ;
			}
		}
		else if ( Mem-> BallX() < -20 && Mem->BallX() > -40 )
		{
			if ( DF_Pos1() == TRUE ) return ;
			if ( DF_Pos2() == TRUE ) return ;
			if ( DF_Pos3() == TRUE ) return ;

			if (go_to_point( MyProp->pos , buffer , 50 ) == AQ_ActionNotQueued )
			{
				face_ball();
				return ;
			}
			return ;		
		}
		else if (Mem->BallX() < -40 )
		{
			if ( Mem->BallInOwnPenaltyArea() )
			{
				if ( Mem->ClosestTeammateToBall() == Mem->MyNumber )
				{
					if ( go_to_point(Mem->BallAbsolutePosition(),buffer) == AQ_ActionNotQueued )
					{
						face_ball() ;
					}
				}
				else
				{
					if ( go_to_point(Vector(Mem->BallX(),Mem->MyY()),buffer) == AQ_ActionNotQueued )
					{
						face_ball() ;
					}
				}
			}
			else
			{
				if ( Mem->ClosestTeammateToBall() == Mem->MyNumber )
				{
					if ( go_to_point(Mem->BallAbsolutePosition(),buffer) == AQ_ActionNotQueued )
					{
						face_ball() ;
					}
				}
				else
				{
					if ( go_to_point(Vector(Mem->BallX(),Mem->MyY()),buffer) == AQ_ActionNotQueued )
					{
						face_ball() ;
					}
				}

				//if ( go_to_mark_position() == TRUE ) return ;
				//face_ball() ;
			}

		}
		else if (Mem->BallWillBeKickable(5, 100))
		{
			if (Mem->PlayerWithBall() <= 0)
			{
				go_to_point(Vector(Mem->BallAbsolutePosition().x-1,Mem->BallAbsolutePosition().y),buffer);
				return ;
			}
			else if ( Mem->PlayerWithBall() == 1 )
			{
				if ( go_to_point(Mem->BallAbsolutePosition(),buffer) == AQ_ActionNotQueued )
				{
					face_ball() ;
				}
				return ;
			}
			else
			{
				if ( go_to_point(Mem->BallAbsolutePosition(),buffer) == AQ_ActionNotQueued )
				{
					face_ball() ;
				}
				return ;
			}
		}
		else if ( Mem->BallX() > 10 )
		{
			Vector v ;
			v = Vector ( Mem->BallX() - 10 , MyProp->pos.y ) ;

			if ( v.x >= -5 )
				v.x = -5 ;

			if (go_to_point( v , 0 , 40 ) == AQ_ActionNotQueued )
			{
				face_ball();
				return ;
			}
			return ;
		}
		else
		{
			if (go_to_point( MyProp->pos ,buffer,45 ) == AQ_ActionNotQueued )
			{
				face_ball() ;
				return ;
			}
			return ;
		}
	}
}
