#include <libCMU.h>
#include <zeng.h>

void RFW_behave()
{
	double buffer = minimal_buffer() ;
	if ( mode_action() == TRUE ) return ;

/*ܡ뤬ʤ*/
	if (!Mem->BallPositionValid()){
		face_ball();
	}
	else
	{
		if ( Mem->BallKickable() )
		{
			double danger_val = get_danger_val ( 20 ) ;

			if ( shoot_near_post() == TRUE ) return ;

			Vector vec = Vector ( 40 , 15 ) ;

			if ( danger_val < 0.3 )
			{
				if ( Mem->my_offside_line <= 10 && Mem->MyX() < 30 )
				{
					if ( forward_pass(vec) == TRUE ) return ;
				}
				if ( MF_pass_forward () == TRUE )	return ;
				if ( MF_pass_side () == TRUE ) return ;
				if ( MF_pass_center () == TRUE ) return ;

				if ( DR_None == DribbleTo(vec , 100 , 0 , Mem->CP_dribble_angle_norm,
					  DM_Lazy, FALSE, vec ) )
				{
					if ( MF_pass_side () == TRUE )	return ;
					if ( MF_pass_forward () == TRUE ) return ;
					if ( MF_pass_center () == TRUE ) return ;

					kick_ball (Vector ( 52.5 , 0 ) , KM_HardestKick ) ;
					return ;
				}
				return ;
			}
			else if ( danger_val < 0.6 )
			{
				if ( Mem->my_offside_line <= 10 && Mem->MyX() < 30 )
				{
					if ( forward_pass(vec) == TRUE ) return ;
				}
				if ( MF_pass_forward () == TRUE ) return ;
				if ( MF_pass_side () == TRUE ) return ;
				if ( MF_pass_center () == TRUE ) return ;
			}
			else
			{
				if ( Mem->my_offside_line <= 10 && Mem->MyX() < 30 )
				{
					if ( forward_pass(vec) == TRUE ) return ;
				}
				if ( MF_pass_forward () == TRUE ) return ;
				if ( MF_pass_side () == TRUE ) return ;
				if ( MF_pass_center () == TRUE )
				{
					return ;
				}
				else
				{
					if ( Mem->DistanceTo(Vector(36.0,10) ) > 10 )
					{
						kick_ball (Vector ( 36.0 , 10 ) , KM_HardestKick ) ;
					}
					else
					{
						kick_ball (Vector ( 36.0 , -10 ) , KM_HardestKick ) ;
					}

					return ;
				}
			}
		}
		else if ( how_many_closer_teammate(Mem->BallAbsolutePosition() ) < 1 && Mem -> PlayerWithBall() <= 0 )
		{
			chase_ball(buffer);
			return ;
		}
		else if ( Mem->BallWillBeKickable( 2 , 100 ) )
		{
			if (Mem->PlayerWithBall() <= 0)/*ŨܡäƤ*/
				go_to_point(Mem->BallAbsolutePosition(),buffer) ;
			else
				chase_ball(buffer) ;
		}
		else
		{
			if ( Mem->BallPositionValid() )
			{
				if ( Mem -> BallAbsolutePosition().x < -25 )
				{
					go_to_point ( Vector(Mem->my_offside_line - 3  , MyProp->pos.y )  ,  buffer , 60 ) ;
				}
				else if ( fabs ( Mem -> BallAbsolutePosition().x - Mem->MyPos().x) > 25
					  && (Mem-> BallAbsolutePosition().x < Mem->MyPos().x) )
				{
					go_to_point(Vector(Mem->my_offside_line - 10 ,MyProp->pos.y ),buffer,80) ;
				}
				else if ( fabs ( Mem -> BallAbsolutePosition().x - Mem->MyPos().x) > 10  )
				{
					if ( Mem->TeammateInOffsidePosition(Mem->MyNumber) )
						go_to_point ( Vector(Mem->my_offside_line - 3,  MyProp->pos.y) , buffer , 40 ) ;
				}
				else
				{
					if ( Mem->TeammateInOffsidePosition(Mem->MyNumber) )
						go_to_point(Vector(Mem->my_offside_line - 3  , MyProp->pos.y),buffer,40) ;
				}
			}
			else
			{
				face_ball();
			}
		}
	}
}
