#include <libCMU.h>
#include <zeng.h>

void check_all( void )
{
	//check_stamina() ;
	//check_ball() ;
	//check_offside_line ();
	//check_player() ;
	check_counter() ;
}

void check_stamina ( void )
{
	printf("Stamina Check : Time (%d) : Stamina (%f) : Effort (%f)\n"
	       , Mem->CurrentTime.t,Mem->MyStamina(),Mem->MyEffort() ) ;
}

void check_ball ( void )
{
	printf("Ball Check : Time (%d) : BallPositionValid (%f)\n"
	       , Mem->CurrentTime.t,Mem->BallPositionValid() ) ;
}

void check_offside_line ( void )
{
	printf("Offside Line Check : Time (%d) : My (%f) : Their (%f)\n"
	       , Mem->CurrentTime.t,Mem->my_offside_line,Mem->their_offside_line ) ;
}

void check_player ( void )
{

	for ( Unum u = 1 ; u <= 11 ; ++ u )
	{
		if ( Mem->TeammatePositionValid(u) )
		{
			printf("Player (Teammate) Check : Time (%d) : TeammatePositionValid (%f) : Position (%f,%f)\n"
			       , Mem->CurrentTime.t,Mem->TeammatePositionValid(u)
			       ,Mem->TeammateAbsolutePosition(u).x
			       , Mem->TeammateAbsolutePosition(u).y ) ;
		}
		else
		{
			printf("Player (Teammate) Check : Time (%d) : Position Unknown\n") ;
		}
	}

	for ( Unum u = 1 ; u <= 11 ; ++ u )
	{
		if ( Mem->OpponentPositionValid(u) )
		{
			printf("Player (Opponent) Check : Time (%d) : OpponentPositionValid (%f) : Position (%f,%f)\n"
			       , Mem->CurrentTime.t,Mem->OpponentPositionValid(u)
			       , Mem->OpponentAbsolutePosition(u).x
			       , Mem->OpponentAbsolutePosition(u).y ) ;
		}
		else
		{
			printf("Player (Opponent) Check : Time (%d) : Position Unknown\n") ;
		}
	}

}

void	check_counter( void )
{
	printf("Counter Check : Time (%d) : Dance (%d) : Say (%d) : Move (%d)\n"
	       , Mem->CurrentTime.t,dance_counter,say_counter,move_counter) ;
}
