#include <geometry.h>

/*	formation.h	*/

#define  FORMATION_VAL		-2
#define  FORMATION_VAL_E	-1
#define  FORMATION_VAL_B	-2

#define  PASS_VAL		 2
#define  PASS_VAL_E		-2
#define  PASS_VAL_B		-1

#define  FIELD_VAL		-1
#define  FIELD_VAL_E		-1
#define  FIELD_VAL_B		+1

class Formation
{
public:
	double team_formation[12][7] ;
	double field[12][7] ;
	double pass[12][7] ;
	double formation[12][7] ;

	Rectangle  field_rect[12][7] ;
	Rectangle  pass_rect[12][7] ;
	Rectangle  formation_rect[12][7] ;

	Formation() ;
	~Formation() ;

	enum RECT_TYPE
	{
		FIELD,
		PASS,
		FORMATION
	} ;

	void init ( void ) ;
	void init_value ( void ) ;
	void update_value ( void ) ;

	void debug_print ( void ) ;
	void debug_rect ( void ) ;

	Bool is_in_rect ( RECT_TYPE type , float x , float y , int * i , int * j ) ;
	Bool Formation::get_max ( RECT_TYPE type , int * ri , int * rj ) ;
} ;
