#include  <stdio.h>
#include  <stdlib.h>
#include  <stddef.h>
#include  <limits.h>
#include  <unistd.h>

static	void	usage( const char *  argv_0 );

static
void   usage( const char *  argv_0 )
{
	(void)fprintf( stderr ,  "Usage: %s microseconds\n" , argv_0 );
}


int    main( int  argc ,  char  *argv[] )
{
	unsigned long	microseconds = 0;
	char *		endp = NULL;

	if ( argc != 2 )
	{
		usage( argv[0] );
		exit( EXIT_FAILURE );
	}

	microseconds = strtoul( argv[1] , &endp , 10 );

	if ( argv[1][0] == '\0' || *endp != '\0' || microseconds == ULONG_MAX )
	{
		usage( argv[0] );
		exit( EXIT_FAILURE );
	}

	(void)usleep( (unsigned int)microseconds );

	return( 0 );
}
